//+------------------------------------------------------------------+
//|                                                       SqW_MA.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int Length=40;
extern int Price=0;    // Applied price
                       // 0 - Close
                       // 1 - Open
                       // 2 - High
                       // 3 - Low
                       // 4 - Median
                       // 5 - Typical
                       // 6 - Weighted  

double SqW_MA[];
double SumP, SumP2;

int init()
  {
   IndicatorShortName("SqW_MA");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SqW_MA);
   
   SumP=Length*(Length-1)/2;
   SumP2=Length*(Length-1)*(2*Length-1)/6;

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
{
 if(Bars<=Length) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 pos=limit;
 double Sum, SumW;
 int i;
 double Pr;
 double var1, var2, var3;
 while(pos>=0)
 {
  Sum=0;
  SumW=0;
  for (i=0;i<Length;i++)
  {
   Pr=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+i);
   Sum=Sum+Pr;
   SumW=SumW+Pr*i;
  }
  var3=SumP2*Length-SumP*SumP;
  var2=(SumW*Length-SumP*Sum)/var3;
  var1=(Sum-SumP*var2)/Length;
  SqW_MA[pos]=var1;
  pos--;
 } 

 return(0);
}

